import { newSpecPage } from "@stencil/core/testing";
import { BpSdkQuoteRequestCoverageList } from "./bp-sdk-quote-request-coverage-list";
const setupPage = async () => {
    return await newSpecPage({
        html: '<bp-sdk-quote-request-coverage-list></bp-sdk-quote-request-coverage-list>',
        components: [BpSdkQuoteRequestCoverageList],
    });
};
const setupInstance = (page) => {
    const instance = page.rootInstance;
    return instance;
};
describe('bp-sdk-quote-request-coverage-list', () => {
    it('renders', async () => {
        const page = await setupPage();
        await page.waitForChanges();
        const element = page.root.querySelector('div');
        expect(element).toBeTruthy();
        expect(page.root.querySelector('bp-sdk-external-quote-request-coverage-list')).toBeFalsy();
    });
    it('renders external component if defined', async () => {
        const whenDefinedMock = jest
            .spyOn(customElements, 'whenDefined')
            .mockResolvedValueOnce({});
        const page = await setupPage();
        await page.waitForChanges();
        expect(page.root.querySelector('bp-sdk-external-quote-request-coverage-list')).toBeTruthy();
        whenDefinedMock.mockRestore();
    });
});
