import { BpSdkStore, searchChoices } from '@boldpenguin/sdk-redux';
import { IAutocompleteNaicsContainerComponent, IChoice, IPartnerEngineConfig, QuestionFieldType } from '@boldpenguin/sdk-types';
import { Unsubscribe } from '../../services/redux-store.service';
export declare class BpSdkAutocompleteNaicsContainer implements IAutocompleteNaicsContainerComponent {
    storeUnsubscribe?: Unsubscribe;
    searchChoices: typeof searchChoices;
    /**
     * Answer id
     */
    answerId: string;
    /**
     * Question id
     */
    questionId: string;
    /**
     * Placeholder to display
     */
    placeholder: string;
    /**
     * Is required value
     */
    required: boolean;
    /**
     * question code
     */
    code: string;
    /**
     * Error messages
     */
    errors: string[];
    /**
     * Error text
     */
    errorText: string | null;
    /**
     * Aria label id's that describes input for screen readers
     */
    labelId: string;
    /***
     * Selected choice
     */
    choiceId: string;
    /***
     * Choices to display
     */
    choices: IChoice[];
    /**
     * Is touched
     */
    touched: boolean;
    /**
     * Is pristine
     */
    pristine: boolean;
    /**
     * Is answer in complete state
     */
    isCompleted: boolean;
    /**
     * When true, the field will be readonly. It will display only the label and value as plain text.
     */
    isReadOnly: boolean;
    /**
     * Field type
     */
    fieldType: QuestionFieldType;
    /**
     * Label to use
     */
    label: string;
    /**
     *  Labels that describe group
     */
    labelledBy: string;
    /**
     * Choices injected from redux
     */
    remoteChoices: IChoice[];
    /**
     * IPartnerEngineConfig injected from redux
     */
    config: IPartnerEngineConfig;
    /**
     * Help text
     */
    helpText: string;
    /**
     * Specifically how the question was answered (ie. "ACORD 126")
     */
    answeredBySource: string | undefined;
    choiceMap: {
        [choiceId: string]: IChoice[];
    };
    composedChoices: IChoice[];
    useExternal: boolean;
    el: HTMLBpSdkAutocompleteInputElement;
    resetState(): void;
    handleSubscriptions: () => void;
    connectedCallback(): void;
    componentWillLoad(): void;
    mapStateToProps: (state: BpSdkStore) => {
        remoteChoices: IChoice[];
        config: IPartnerEngineConfig;
    };
    disconnectedCallback(): void;
    onQuestionIdChange(): void;
    onChoicesChange(choices: IChoice[]): void;
    onChoicesUpdate(choices: IChoice[]): void;
    onChoiceMapUpdate(choiceMap: {
        [choiceId: string]: IChoice[];
    }): void;
    updateComposedChoices(searchChoices: IChoice[], choiceMap: {
        [choiceId: string]: IChoice[];
    }): void;
    onFilterUpdate({ detail }: {
        detail: any;
    }): void;
    render(): any[];
    renderExternal(): any;
    renderInternal(): any;
}
