import { BpSdkStore, removeActiveAnswerId } from '@boldpenguin/sdk-redux';
import { IGooglePlacesAutocompleteContainerComponent, QuestionFieldType, QuestionReferenceType } from '@boldpenguin/sdk-types';
import { Unsubscribe } from '../../services/redux-store.service';
export declare class BpSdkGooglePlacesAutocompleteContainer implements IGooglePlacesAutocompleteContainerComponent {
    storeUnsubscribe?: Unsubscribe;
    removeActiveAnswerId: typeof removeActiveAnswerId;
    /**
     * Answer id
     */
    answerId: string;
    /**
     * Question code
     */
    code: string;
    /**
     * Aria label by id
     */
    labelId: string;
    /**
     * placeholder
     */
    placeholder: string;
    /**
     * Filter text
     */
    filter: string;
    /**
     * Label to use
     */
    label: string;
    /**
     *  Labels that describe group
     */
    labelledBy: string;
    /**
     * Is required
     */
    required: boolean;
    /**
     * Error messages
     */
    errors: string[];
    /**
     * Error text
     */
    errorText: string;
    /**
     * is touched
     */
    touched: boolean;
    /**
     * is pristine
     */
    pristine: boolean;
    /**
     * Is answer in complete state
     */
    isCompleted: boolean;
    /**
     * When true, the field will be readonly. It will display only the label and value as plain text.
     */
    isReadOnly: boolean;
    /**
     * Question id
     */
    questionId: string;
    /**
     * Field type
     */
    fieldType: QuestionFieldType;
    /**
     * minimum length of input
     */
    min: number;
    /**
     * maximum length of input
     */
    max: number;
    /**
     * Reference type
     */
    referenceType: QuestionReferenceType | null;
    /**
     * Help text
     */
    helpText: string;
    /**
     * Google API token
     */
    googleApiToken: string;
    /**
     * Is autocomplete enabled
     */
    isAutocompleteEnabled: boolean;
    /**
     * Specifically how the question was answered (ie. "ACORD 126")
     */
    answeredBySource: string | undefined;
    autoComplete: string;
    useExternal: boolean;
    el: HTMLBpSdkGooglePlacesAutocompleteContainerElement;
    resetState(): void;
    handleSubscriptions: () => void;
    connectedCallback(): void;
    componentWillLoad(): void;
    mapStateToProps: (state: BpSdkStore) => {
        googleApiToken: string;
        isAutocompleteEnabled: boolean;
    };
    onPlacesUpdate(): void;
    onReferenceTypeChange(referenceType: QuestionReferenceType | null): void;
    onCodeChange(code: string): void;
    onFieldTypeChange(fieldType: QuestionFieldType): void;
    onIsAutocompleteEnabledChange(isAutocompleteEnabled: boolean): void;
    updateAutocomplete({ code, fieldType, referenceType, isAutocompleteEnabled, }: {
        referenceType: QuestionReferenceType | null;
        code: string;
        fieldType: QuestionFieldType;
        isAutocompleteEnabled: boolean;
    }): void;
    disconnectedCallback(): void;
    render(): any[];
    renderExternal(): any;
    renderInternal(): any;
}
