import { BpSdkStore } from '@boldpenguin/sdk-redux';
import { ICarrier, IConfigOptions, IQuoteRequestLogoContainerComponent, IQuotesState } from '@boldpenguin/sdk-types';
import { Unsubscribe } from '../../services/redux-store.service';
export declare class BpSdkQuoteRequestLogoContainer implements IQuoteRequestLogoContainerComponent {
    storeUnsubscribe?: Unsubscribe;
    /**
     * Carrier information
     */
    carrier: ICarrier;
    /**
     * Custom logo base url
     */
    customLogoBaseUrl: string;
    /**
     * Show logo
     */
    showLogo: boolean;
    /**
     * Show custom logo
     */
    showCustomLogo: boolean;
    /**
     * Quote ID
     */
    quoteId: string;
    /**
     * Render supplier logo instead of carrier logo, injected from redux
     */
    shouldRenderSupplierLogo: boolean;
    /**
     * Web component config options injected from redux
     */
    configOptions: IConfigOptions;
    /**
     * Quote, injected from redux
     */
    quote: IQuotesState;
    useExternal: boolean;
    name: string;
    logoUrl: string;
    resetState(): void;
    componentWillLoad(): void;
    mapStateToProps: (state: BpSdkStore) => {
        shouldRenderSupplierLogo: boolean;
        quote: IQuotesState;
    };
    handleSubscriptions: () => void;
    connectedCallback(): void;
    onCarrierChange(carrier: ICarrier): void;
    onCustomLogoBaseUrlChange(customLogoBaseUrl: string): void;
    onShowCustomLogoChange(showCustomLogo: boolean): void;
    onShouldRenderSupplierLogoChange(shouldRenderSupplierLogo: boolean): void;
    updateLogoUrl(carrier: ICarrier, baseUrl: string, showCustomLogo: boolean, renderSupplierLogo?: boolean): void;
    render(): any[];
    renderExternal(): any;
    renderInternal(): any;
}
